import locale

# Verwendung der Umgebungsvariablen LANG fuer das Initialisieren von locale
import os
lang = os.environ['LANG']
print(lang)
loc = locale.setlocale(locale.LC_ALL, lang)
print("setlocale:", loc)

loc = locale.getlocale()
print(loc) # liefert ('de_DE', 'UTF-8')

locale.setlocale(locale.LC_ALL, '') # use user's preferred locale
#locale.setlocale(locale.LC_ALL, 'de_DE') # use Germany
#locale.setlocale(locale.LC_ALL, 'en_US') # use USA
#locale.setlocale(locale.LC_ALL, 'da_DK') # use Daenemark
#locale.setlocale(locale.LC_ALL, 'en_GB') # use GB
#locale.setlocale(locale.LC_ALL, 'zh_CN') # use China
#locale.setlocale(locale.LC_ALL, 'zh_HK') # use Hongkonk
# locale wird stinkig, wenn die POSIX-Komination nicht existiert

# Darstellen einer Zahl als Zeichenkette
wert = 12345.67
#locale.setlocale(locale.LC_ALL, 'de_DE') # use Germany
locale.setlocale(locale.LC_ALL, 'en_US') # use USA
zeichenkette = locale.str(wert)
print(zeichenkette) # Dezimalkomma, aber keine Tausendertrennzeichen
zahl = locale.atof(zeichenkette)
print(zahl) # Dezimalkomma, aber keine Tausendertrennzeichen

locenv = locale.localeconv()
dezimaltrennzeichen = locenv['decimal_point']
print('dezimaltrennzeichen', dezimaltrennzeichen)
waehrungsdezimaltrennzeichen = locenv['mon_decimal_point']
print('waehrungsdezimaltrennzeichen', waehrungsdezimaltrennzeichen)
tausendertrennzeichen =  locenv['thousands_sep']
print('tausendertrennzeichen', tausendertrennzeichen)
lokalWaehrungssymbol = locenv['currency_symbol']
print('lokalWaehrungssymbol', lokalWaehrungssymbol)
internationalesWaehungssymbol = locenv['int_curr_symbol']
print('internationalesWaehungssymbol', internationalesWaehungssymbol)

# ermittelt die Kodierung
kodierung = locale.nl_langinfo(locale.CODESET)
print("Kodierung:", kodierung)
import time
format = locale.nl_langinfo(locale.D_T_FMT)
# locale.D_T_FMT # DateTime
# locale.D_FMT # Date
# locale.T_FMT # Time
print(format)
print(time.strftime(format, time.localtime(time.time())))
print(time.strftime(format))
print(time.strftime("%a %d %b %Y %T %Z"))


