import tkinter

class EntryTable(tkinter.Frame):
    def __init__(self, eltern, rows=10, columns=2):
        tkinter.Frame.__init__(self, eltern)
        self.zeilen = rows
        self.spalten = columns
        self.widgets = []
        for zeile in range(rows):
            widgetzeile = []
            for spalte in range(columns):
                zelle = tkinter.Entry(self, width=10,
                        disabledforeground="black")
                zelle.grid(row=zeile, column=spalte) #, sticky="nsew")
                widgetzeile.append(zelle)
            self.widgets.append(widgetzeile)
        for spalte in range(columns):
            self.grid_columnconfigure(spalte, weight=1)

    def setZelle(self, row, column, value):
        if row>=self.zeilen or column>=self.spalten:
            return
        widget = self.widgets[row][column]
        widget["state"] = tkinter.NORMAL
        widget.delete(0, tkinter.END)
        widget.insert(tkinter.END, value)
        widget["state"] = tkinter.DISABLED
        if type(value) in (int, float):
            widget.configure(justify=tkinter.RIGHT)
        else:
            widget.configure(justify=tkinter.LEFT)

# Testprogramm fuer die Tabellenklasse
if __name__ == "__main__":
    fenster = tkinter.Tk()
    zeilen = 7
    spalten = 4
    tab = EntryTable(fenster, rows=zeilen, columns=spalten)
    tab.pack(side="top", fill="x")
    for i in range(zeilen):
        for j in range(spalten):
           tab.setZelle(row=i, column=j, value=(i+1)*(j+1))
    tab.setZelle(2, 1, "Netter")
    tab.setZelle(4, 2, "Tabelleninhalt")
    fenster.mainloop()

