# Mit diesem Programm kann man die verschiedenen
# Datenbankoperationen mit verschiedenen Datenbanken
# durch Auskommentieren und Dekommentieren einzelner
# Zeilen ausprobieren.

#import sqlite3 as db
#import pg as db
#import postgresql
import psycopg2 as db
#import MySQLdb as db
#import mysql
#import mysql.connector as db

def create(cursor):
    cursor.execute("""CREATE TABLE lager ( 
        fachnummer INTEGER, seriennummer INTEGER, 
        komponente TEXT, lieferant TEXT, reserviert INTEGER)""")
    cursor.execute("""CREATE TABLE lieferanten ( 
        kurzname TEXT, name TEXT, telefonnummer TEXT)""") 
    cursor.execute("""CREATE TABLE Kunde ( 
        kundennr INT primary key, name TEXT, anschrift TEXT)""")
    cursor.execute("""CREATE TABLE Ware ( 
        artikelnr INT primary key, preis dec(10, 2), bezeichnung TEXT)""")
    cursor.execute("""CREATE TABLE Verkauf ( 
        verkaufnr INT primary key, datum date, preis dec(10, 2),
        artikel int REFERENCES Ware (artikelnr),
        kunde int REFERENCES Kunde (kundennr) )""")

def simpleinsert(cursor):
    cursor.execute("""INSERT INTO lager VALUES ( 
        1, 26071987, 'Grafikkarte Typ 1', 'FC', 0)""")
    cursor.execute("""INSERT INTO Verkauf VALUES ( 
        1, '2015/01/15', 1.95, 12, NULL)""")

def dictionaryInsert(cursor):
    werte = {"kurz" : "DR", "name" : "Danger Electronics", "telefon" : "123456"} 
    sql = "INSERT INTO lieferanten VALUES (:kurz, :name, :telefon)" 
    cursor.execute(sql, werte)

def listInsert(cursor):
    for row in ((1, "2607871987", "Grafikkarte Typ 1", "FC", 0), 
            (2, "19870109", "Prozessor Typ 13", "LPE", 57), 
            (10, "06198823", "Netzteil Typ 3", "FC", 0), 
            (25, "11198703", "LED-Luefter", "FC", 57), 
            (26, "19880105", "Festplatte 128 GB", "LPE", 12)): 
        cursor.execute("INSERT INTO lager VALUES (?,?,?,?,?)", row)

def manyInsert(cursor):
    lieferanten = (("FC", "FiboComputing Inc.", "011235813"), 
               ("LPE", "LettgenPetersErnesti", "026741337"), 
               ("GC", "Golden Computers", "016180339")) 
    cursor.executemany("INSERT INTO lieferanten VALUES (?,?,?)", lieferanten) 
 
    kunden = ((12, "Heinz Elhurg", "Turnhallenstr. 1, 3763 Sporthausen"), 
          (57, "Markus Altbert", u"K\xe4mperweg 24, 2463 Duisschloss"), 
          (64, "Steve Apple", "Podmacstr 2, 7467 Iwarhausen")) 
    cursor.executemany("INSERT INTO Kunde VALUES (?,?,?)", Kunde)


def createandfill(cursor):
    create(cursor)
    simpleinsert(cursor)
    dictionaryInsert(cursor)
    listInsert(cursor)
    manyInsert(cursor)
    connection.commit()

def fetch(cursor):
    sql = """ SELECT * FROM Verkauf"""
    cursor.execute(sql) 
    ergebnis = cursor.fetchall() 
    if ergebnis:
        #for verkaufnr, artikel, kunde in ergebnis:
        #    print("{} {} {}".format(verkaufnr, artikel, kunde))
        for verkaufnr in ergebnis:
            print("{}".format(verkaufnr))
    else:
        print("kein Ergebnis")

def fetchmore(cursor):
    sql = """ 
SELECT lager.fachnummer, lager.komponente, lieferanten.name 
FROM lager, lieferanten 
WHERE lieferanten.telefonnummer='011235813' AND 
      lager.lieferant=lieferanten.kurzname""" 
    cursor.execute(sql) 
    ergebnis = cursor.fetchall() 
    if ergebnis:
        for fachnr, komponente, name in ergebnis:
            print("{:6} {:30} {:30}".format(fachnr, komponente, name))

connection = db.connect(host='localhost', port=5432,
         database='dbname',
         user='dbuser', password='geheim')
cursor = connection.cursor()
# createandfill(cursor)
# create(cursor)
connection.commit()
simpleinsert(cursor)
#fetchmore(cursor)
fetch(cursor)
connection.close()

