import MySQLdb as db

def create(cursor):
    #cursor.execute("""CREATE TABLE lager ( 
    #    fachnummer INTEGER, seriennummer INTEGER, 
    #    komponente TEXT, lieferant TEXT, reserviert INTEGER)""")
    #cursor.execute("""CREATE TABLE lieferanten ( 
    #    kurzname TEXT, name TEXT, telefonnummer TEXT)""") 
    try:
        cursor.execute("""CREATE TABLE Kunde ( 
            kundennr INT primary key, name TEXT, anschrift TEXT)""")
        cursor.execute("""CREATE TABLE Ware ( 
            artikelnr INT primary key, preis dec(10, 2), bezeichnung TEXT)""")
        cursor.execute("""CREATE TABLE Verkauf ( 
            verkaufnr INT primary key auto_increment, 
            datum date, preis dec(10, 2),
            artikel int REFERENCES Ware (artikelnr),
            kunde int REFERENCES Kunde (kundennr) )""")
    except db.DatabaseError:
        print("Tabellenerzeugung gelingt nicht.")

def simpleinsert(cursor):
    cursor.execute("""INSERT INTO lager VALUES ( 
        1, 26071987, 'Grafikkarte Typ 1', 'FC', 0)""")

def verkauf(cursor, kunde, ware, preis):
    try:
        sqlBefehl = """INSERT INTO Verkauf (datum, preis, artikel, kunde)
                VALUES ( 
                DATE(NOW()), {}, {}, {})""".format(preis, ware, kunde)
        cursor.execute(sqlBefehl)
    except db.DatabaseError as e:
        print("Verkaufen klappt nicht")
        print(e.message)
        print(e.args)
        print("------------")

def insertKunden(cursor):
    try:
        for kunde in ((1, "Batman", "Gotham City"), 
                (7, "James Bond", "London"), 
                (12, "Spiderman", "New York"), 
                (13, "Otto", "Leer"), 
                (14, "Napoleon", "Buxtehude")): 
            cursor.execute(
                  "INSERT INTO Kunde VALUES ({},'{}','{}')".format(
                  kunde[0], kunde[1], kunde[2]))
    except db.DatabaseError as e:
        print("Einfuegen der Kunden klappt nicht")
        print(e.message)

def insertWaren(cursor):
    try:
        warenliste = [(1, 1.24, "Lakritzschnecken"), 
                (2, 2.12, "Lakritzsalmiak"), 
                (3, 34.98, "Spiderman-Hosen"), 
                (4, 2.90, "Superman-Comic")]
        cursor.executemany("INSERT INTO Ware VALUES (%s,%s,%s)", warenliste)
    except db.DatabaseError as e:
        print("Einfuegen der Ware klappt nicht")
        print(e.message)


def createandfill(cursor):
    create(cursor)
    insertKunden(cursor)
    dictionaryInsert(cursor)
    listInsert(cursor)
    manyInsert(cursor)
    connection.commit()

def fetch(cursor):
    try:
        sql = """ SELECT verkaufnr, artikel, kunde FROM Verkauf"""
        cursor.execute(sql) 
        ergebnis = cursor.fetchall() 
        if ergebnis:
            for verkaufnr, artikel, kunde in ergebnis:
                print("{} {} {}".format(verkaufnr, artikel, kunde))
            for verkaufnr in ergebnis:
                print("{}".format(verkaufnr))
        else:
            print("kein Ergebnis")
    except db.DatabaseError as e:
        print("Auslesen klappt nicht")
        print(e.message)

def fetchkunde(cursor):
    sql = "SELECT kundennr, name, anschrift FROM Kunde"
    cursor.execute(sql) 
    ergebnis = cursor.fetchall() 
    if ergebnis:
        for nr, name, adresse in ergebnis:
            print("{:6} {:30} {:30}".format(nr, name, adresse))

def fetchlakritz(cursor):
    sql = """ 
        SELECT Kunde.name, Ware.bezeichnung
        FROM Kunde, Ware, Verkauf
        WHERE Ware.bezeichnung LIKE 'Lakritz%' AND 
        Verkauf.artikel=Ware.artikelnr AND
        Verkauf.kunde=Kunde.kundennr"""
    cursor.execute(sql) 
    ergebnis = cursor.fetchall() 
    if ergebnis:
        for kunde, ware in ergebnis:
            print("{:30} {:30}".format(kunde, ware))

connection = db.connect(host='localhost',
         db='dbname',
         user='dbuser', passwd='geheim')
cursor = connection.cursor()
# createandfill(cursor)
create(cursor)
insertKunden(cursor)
connection.commit()
insertWaren(cursor)
#simpleinsert(cursor)
verkauf(cursor, kunde=1, ware=1, preis=1.23)
verkauf(cursor, kunde=7, ware=2, preis=1.23)
connection.commit()
fetchlakritz(cursor)
#fetch(cursor)
#fetchkunde(cursor)
connection.close()

