import xml.etree.ElementTree as ET
import sqlite3 as db
# Eröffne die Datenbank
connection = db.connect("kunde.db")
cursor = connection.cursor()
# Falls nicht vorhanden, erzeuge die Tabelle
try:
    cursor.execute("""CREATE TABLE Kunde (
        kdnr INTEGER, name TEXT, anschrift TEXT)""")
except db.DatabaseError:
    print("Table nicht angelegt")
# Lese die XML-Datei ein
baum = ET.parse('input.xml')
root = baum.getroot()
for knoten in root:
    elementliste = list(knoten)
    kdnr = ""
    name = ""
    anschrift = ""
    for element in elementliste:
        if element.tag=="kdnr":
            kdnr = element.text
        if element.tag=="name":
            name = element.text
        if element.tag=="anschrift":
            anschrift = element.text
    # Satz fertig, ab damit in die Datenbank
    cursor.execute("insert into Kunde " + \
            " (kdnr, name, anschrift) values " + \
            "({}, '{}', '{}')".format(kdnr, name, anschrift))
# Neue XML-Datei erstellen
kundenliste = ET.Element("kundenliste")
baum = ET.ElementTree(kundenliste)
# Nun lesen wir die Datenbank aus
sql = "SELECT kdnr, name, anschrift FROM Kunde"
cursor.execute(sql)
ergebnis = cursor.fetchall()
if ergebnis:
    # Satzweise in die XML-Struktur einlesen
    for kdnr, name, anschrift in ergebnis:
        neukunde = ET.SubElement(kundenliste, "kunde")
        xmlkdnr = ET.SubElement(neukunde, 'kdnr')
        xmlkdnr.text = str(kdnr)
        xmlname = ET.SubElement(neukunde, 'name')
        xmlname.text = name
        xmlanschrift = ET.SubElement(neukunde, 'anschrift')
        xmlanschrift.text = anschrift
# Datenbank schließen
connection.commit()
connection.close()
# XML-Datei schreiben
baum.write('output.xml')

