# Beispielprogramm Bermuda aus dem Buch Arnold Willemer: Python
# erschienen im Verlag Wrox

import random

TREFFER = 9
MAXSCHIFF = 4
NORD = 1
NORDWEST = 2
WEST = 3
SUEDWEST = 4
SUED = 5
SUEDOST = 6
OST = 7
NORDOST = 8

class Koordinate:
    def __init__(self):
        self.x = 0
        self.y = 0

    def __eq__(self, koord):
        return self.x==koord.x and self.y==koord.y

    def __ne__(self, koord):
        return self.x!=koord.x or self.y!=koord.y

    def __str__(self):
        return "{}, {}".format(self.x, self.y)

class Schiff:
    def __init__(self):
        self.pos = Koordinate()
        self.neusetzen()
        self.gefunden = False

    def neusetzen(self):
        self.pos.x = random.randint(0, 8)
        self.pos.y = random.randint(0, 6)

    def peile(self, x, y):
        # Ist dieses Schiff getroffen?
        if x==self.pos.x and y==self.pos.y:
            self.gefunden = True
            return TREFFER
        if x==self.pos.x:
            if y<self.pos.y:
                return OST
            else:
                return WEST
        if y==self.pos.y:
            if x<self.pos.x:
                return NORD
            else:
                return SUED
        if x-self.pos.x == y-self.pos.y:
            if x<self.pos.x:
                return SUEDWEST
            else:
                return NORDOST
        if x-self.pos.x == (y-self.pos.y)*-1:
            if x<self.pos.x:
                return NORDWEST
            else:
                return SUEDOST
        return 0

spielfeld = [['+' for y in range(7)] for x in range(9)]

def zeigFeld():
    print("   A B C D E F G H I")
    for y in range(7):
        print(chr(ord('1')+y), end="  ")
        for x in range(9):
            print(spielfeld[x][y], end=" ")
        print("")

schiffe = []

def doppelSchiffCheck():
    testSchiff = 0
    while testSchiff < MAXSCHIFF:
        vorSchiff = 0
        while vorSchiff < testSchiff:
            # print(i, testSchiff) # Zeigt die verglichenen Schiffe
            if schiffe[vorSchiff].pos == schiffe[testSchiff].pos:
                schiffe[testSchiff].neusetzen()
                testSchiff -= 1 # dieses Schiff erneut testen
                vorSchiff = -1 # alle bisherigen Schiffe vergleichen
            vorSchiff += 1
        testSchiff += 1

def alleSchiffeGefunden():
    for schiff in schiffe:
        if not(schiff.gefunden):
            print("nicht gefunden:",schiff.pos)
            return False
    return True

def peile(x, y):
    richtungen = [0 for x in range(8)]
    for schiff in schiffe:
        richtung = schiff.peile(x, y)
        if richtung == TREFFER:
            return TREFFER
        if richtung>0:
            richtungen[richtung-1] = 1
    return sum(richtungen)

for i in range(MAXSCHIFF):
    schiffe.append(Schiff())
doppelSchiffCheck()
for i in range(MAXSCHIFF):# zum Debuggen:
    print(schiffe[i].pos) # zeig Schiffspositionen
spielende = False
while not(spielende):
    zeigFeld()
    koord = input("Suche in Koordinate (zB C3)")
    if len(koord)==2:
        x = ord(koord[0]) - ord('A')
        y = ord(koord[1]) - ord('1')
        peilungen=peile(x, y)
        if peilungen >= TREFFER: # Schiff gefunden
            spielfeld[x][y] = '*'
            if alleSchiffeGefunden():
                print("Gewonnen")
                spielende = True
        else:
            spielfeld[x][y] = chr(peilungen + ord('0'))
    else:
        spielende = True

